=== debian/changelog ===
cmtk (3.0.0-1ubuntu1) trusty; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/control: Use libtiff-dev instead of libtiff4-dev build-dependency.
  * Drop cmake2.8.10-compat.patch, as it is no longer necessary.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 14 Jan 2014 23:29:16 -0500

cmtk (3.0.0-1) unstable; urgency=low

  * New major upstream bugfix release - see README and changelog
    for details:
    - affine transformation matrices (were broken when shear and
      non-isotropic scale were used)
    - handling of NIfTI qform and sform has changed
    - fit_spline_xform, xform2scalar etc. might produce different
      output now
    - should be compatible with cmake 2.8.10 (Closes: #697410)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 10 Jan 2014 09:34:59 -0500

cmtk (2.2.6-1ubuntu2) trusty; urgency=low

  * Use libtiff-dev instead of libtiff4-dev build-dependency.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Thu, 05 Dec 2013 22:48:25 +0000

cmtk (2.2.6-1ubuntu1) raring; urgency=low

  * cmake2.8.10-compat.patch: fix ftbfs due to new cmake

 -- Julian Taylor <jtaylor@ubuntu.com>  Sun, 06 Jan 2013 02:42:11 +0100
